<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DigestAuthenticationProvider.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.auth</a> &gt; <span class="el_source">DigestAuthenticationProvider.java</span></div><h1>DigestAuthenticationProvider.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.auth;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.server.ServerCnxn;

<span class="fc" id="L30">public class DigestAuthenticationProvider implements AuthenticationProvider {</span>
<span class="fc" id="L31">    private static final Logger LOG =</span>
<span class="fc" id="L32">        LoggerFactory.getLogger(DigestAuthenticationProvider.class);</span>

    /** specify a command line property with key of 
     * &quot;zookeeper.DigestAuthenticationProvider.superDigest&quot;
     * and value of &quot;super:&lt;base64encoded(SHA1(password))&gt;&quot; to enable
     * super user access (i.e. acls disabled)
     */
<span class="fc" id="L39">    private final static String superDigest = System.getProperty(</span>
        &quot;zookeeper.DigestAuthenticationProvider.superDigest&quot;);

    public String getScheme() {
<span class="fc" id="L43">        return &quot;digest&quot;;</span>
    }

    static final private String base64Encode(byte b[]) {
<span class="fc" id="L47">        StringBuilder sb = new StringBuilder();</span>
<span class="fc bfc" id="L48" title="All 2 branches covered.">        for (int i = 0; i &lt; b.length;) {</span>
<span class="fc" id="L49">            int pad = 0;</span>
<span class="fc" id="L50">            int v = (b[i++] &amp; 0xff) &lt;&lt; 16;</span>
<span class="pc bpc" id="L51" title="1 of 2 branches missed.">            if (i &lt; b.length) {</span>
<span class="fc" id="L52">                v |= (b[i++] &amp; 0xff) &lt;&lt; 8;</span>
            } else {
<span class="nc" id="L54">                pad++;</span>
            }
<span class="fc bfc" id="L56" title="All 2 branches covered.">            if (i &lt; b.length) {</span>
<span class="fc" id="L57">                v |= (b[i++] &amp; 0xff);</span>
            } else {
<span class="fc" id="L59">                pad++;</span>
            }
<span class="fc" id="L61">            sb.append(encode(v &gt;&gt; 18));</span>
<span class="fc" id="L62">            sb.append(encode(v &gt;&gt; 12));</span>
<span class="pc bpc" id="L63" title="1 of 2 branches missed.">            if (pad &lt; 2) {</span>
<span class="fc" id="L64">                sb.append(encode(v &gt;&gt; 6));</span>
            } else {
<span class="nc" id="L66">                sb.append('=');</span>
            }
<span class="fc bfc" id="L68" title="All 2 branches covered.">            if (pad &lt; 1) {</span>
<span class="fc" id="L69">                sb.append(encode(v));</span>
            } else {
<span class="fc" id="L71">                sb.append('=');</span>
            }
<span class="fc" id="L73">        }</span>
<span class="fc" id="L74">        return sb.toString();</span>
    }

    static final private char encode(int i) {
<span class="fc" id="L78">        i &amp;= 0x3f;</span>
<span class="fc bfc" id="L79" title="All 2 branches covered.">        if (i &lt; 26) {</span>
<span class="fc" id="L80">            return (char) ('A' + i);</span>
        }
<span class="fc bfc" id="L82" title="All 2 branches covered.">        if (i &lt; 52) {</span>
<span class="fc" id="L83">            return (char) ('a' + i - 26);</span>
        }
<span class="fc bfc" id="L85" title="All 2 branches covered.">        if (i &lt; 62) {</span>
<span class="fc" id="L86">            return (char) ('0' + i - 52);</span>
        }
<span class="fc bfc" id="L88" title="All 2 branches covered.">        return i == 62 ? '+' : '/';</span>
    }

    static public String generateDigest(String idPassword)
            throws NoSuchAlgorithmException {
<span class="fc" id="L93">        String parts[] = idPassword.split(&quot;:&quot;, 2);</span>
<span class="fc" id="L94">        byte digest[] = MessageDigest.getInstance(&quot;SHA1&quot;).digest(</span>
<span class="fc" id="L95">                idPassword.getBytes());</span>
<span class="fc" id="L96">        return parts[0] + &quot;:&quot; + base64Encode(digest);</span>
    }

    public KeeperException.Code 
        handleAuthentication(ServerCnxn cnxn, byte[] authData)
    {
<span class="fc" id="L102">        String id = new String(authData);</span>
        try {
<span class="fc" id="L104">            String digest = generateDigest(id);</span>
<span class="fc bfc" id="L105" title="All 2 branches covered.">            if (digest.equals(superDigest)) {</span>
<span class="fc" id="L106">                cnxn.addAuthInfo(new Id(&quot;super&quot;, &quot;&quot;));</span>
            }
<span class="fc" id="L108">            cnxn.addAuthInfo(new Id(getScheme(), digest));</span>
<span class="fc" id="L109">            return KeeperException.Code.OK;</span>
<span class="nc" id="L110">        } catch (NoSuchAlgorithmException e) {</span>
<span class="nc" id="L111">            LOG.error(&quot;Missing algorithm&quot;,e);</span>
        }
<span class="nc" id="L113">        return KeeperException.Code.AUTHFAILED;</span>
    }

    public boolean isAuthenticated() {
<span class="fc" id="L117">        return true;</span>
    }

    public boolean isValid(String id) {
<span class="nc" id="L121">        String parts[] = id.split(&quot;:&quot;);</span>
<span class="nc bnc" id="L122" title="All 2 branches missed.">        return parts.length == 2;</span>
    }

    public boolean matches(String id, String aclExpr) {
<span class="fc" id="L126">        return id.equals(aclExpr);</span>
    }

    /** Call with a single argument of user:pass to generate authdata.
     * Authdata output can be used when setting superDigest for example. 
     * @param args single argument of user:pass
     * @throws NoSuchAlgorithmException
     */
    public static void main(String args[]) throws NoSuchAlgorithmException {
<span class="nc bnc" id="L135" title="All 2 branches missed.">        for (int i = 0; i &lt; args.length; i++) {</span>
<span class="nc" id="L136">            System.out.println(args[i] + &quot;-&gt;&quot; + generateDigest(args[i]));</span>
        }
<span class="nc" id="L138">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>